var moveSpeed:float = 6.0;
var turnSpeed:float = 100.0;
var jumpForce:float = 821.379;		
var groundCastLength:float=0.51;

var cameraMain : GameObject;
var camera1 : GameObject;
var camera2 : GameObject;
var camera3 : GameObject;
var camera4 : GameObject;
var camera5 : GameObject;
var camera6 : GameObject;

var cutscenemode : boolean=false;

var triggered1 : boolean=false;
var triggered2 : boolean=false;
var triggered3 : boolean=false;
var triggered4 : boolean=false;
var triggered5 : boolean=false;
var triggered6 : boolean=false;


var conv1 : String[] = ["I am so ugly."];
var conv2 : String[] = ["I'm covered in spots","My ears are big and stick out","I can't stand to look at myself."];
var conv3 : String[] = ["I did art in school.","When it was my turn to pose for the class","the teacher threw a blanket over my head","\"To teach fabric rendering\", she said."];
var conv4 : String[] = ["Please don't make me pose for photos.","I hate photographs","I hate looking at myself."];
var conv5 : String[] = ["As a birthday present","My mother got all the family albums","Cut out every photo of me","Assembled a montage of all the cuttings","framed it","and hung it on my bedroom wall."];
var conv6 : String[] = ["\"Mmm\", he said, as we made out on the couch.","\"You're sexy\"","\"You have such sexy ears.\", he said.","\"Let me touch your ears.\""];

static var toTrigger : int=-1;

var textStage : int = -1;
var sceneNumber : int = -1;

function Start () {
	cutscenemode=false;
	toTrigger=-1;
	textStage=-1;
	sceneNumber=-1;
	triggered1=false;
	triggered2=false;
	triggered3=false;
	triggered4=false;
	triggered5=false;
	triggered6=false;
	
   	cameraMain.camera.enabled = true;
   	camera1.camera.enabled = false;
   	camera2.camera.enabled = false;
   	camera3.camera.enabled = false;
   	camera4.camera.enabled = false;
   	camera5.camera.enabled = false;
   	camera6.camera.enabled = false;
   	
   	DisplayText();
}

function ActivateCamera( n : int)
{
      cameraMain.camera.enabled = false;
      camera1.camera.enabled = false;
      camera2.camera.enabled = false;
      camera3.camera.enabled = false;
      camera4.camera.enabled = false;
      camera5.camera.enabled = false;
      camera6.camera.enabled = false;
      
      switch (n)
      {
      	case -1:
      		cameraMain.camera.enabled = true;
      		break;
      	case 1:
      		camera1.camera.enabled = true;
      		break;
      	case 2:
      		camera2.camera.enabled = true;
      		break;
      	case 3:
      		camera3.camera.enabled = true;
      		break;
      	case 4:
      		camera4.camera.enabled = true;
      		break;
      	case 5:
      		camera5.camera.enabled = true;
      		break;
      	case 6:
      		camera6.camera.enabled = true;
      		break;
      }	
}

function DisplayText () {
	switch (sceneNumber)
	{
		case -1:
			renderer.enabled=true;
			GameObject.Find("GUI Text").gameObject.guiText.text="";
		break;
		case 1:
			renderer.enabled=false;
			GameObject.Find("GUI Text").gameObject.guiText.text=conv1[textStage];
		break;
		case 2:
			renderer.enabled=false;
			GameObject.Find("GUI Text").gameObject.guiText.text=conv2[textStage];
		break;
		case 3:
			renderer.enabled=false;
			GameObject.Find("GUI Text").gameObject.guiText.text=conv3[textStage];
		break;
		case 4:
			renderer.enabled=false;
			GameObject.Find("GUI Text").gameObject.guiText.text=conv4[textStage];
		break;
		case 5:
			renderer.enabled=false;
			GameObject.Find("GUI Text").gameObject.guiText.text=conv5[textStage];
		break;
		case 6:
			renderer.enabled=false;
			GameObject.Find("GUI Text").gameObject.guiText.text=conv6[textStage];
		break;
	}
	
}

function Update () {   
	/*
	if (Input.GetButtonDown("Jump"))
	{
		transform.position.z += 1.0;
	}
	*/
	if (cutscenemode)
	{
		// deal with space being pressed
		if (Input.GetButtonDown("Jump"))
		{
		audio.Play(); 
		textStage++;
		var convLen:int;
		switch (sceneNumber)
		{
			case 1:
				convLen=conv1.length;
				break;
			case 2:
				convLen=conv2.length;
				break;
			case 3:
				convLen=conv3.length;
				break;
			case 4:
				convLen=conv4.length;
				break;
			case 5:
				convLen=conv5.length;
				break;
			case 6:
				convLen=conv6.length;
				break;
		}
		
		if (textStage>=convLen)
		{
			if (sceneNumber==6)
			{		
				Application.LoadLevel(0);
				return;
			}
			textStage=-1;
			sceneNumber=-1;
			ActivateCamera(-1);
			cutscenemode=false;
			DisplayText();
		}
		else
		{
			DisplayText();
		}
		}
		return;
		
	}
	
	switch(toTrigger)
	{
		case (-1):
			break;		
		case 1:
			if (triggered1)
			{
				break;
			}
			triggered1=true;			
			cutscenemode=true;
			ActivateCamera(toTrigger);
			sceneNumber=toTrigger;
			textStage=0;
			DisplayText();
			break;
		case 2:
			if (triggered2)
			{
				break;
			}
			triggered2=true;			
			cutscenemode=true;
			ActivateCamera(toTrigger);
			sceneNumber=toTrigger;
			textStage=0;
			DisplayText();
			break;
		case 3:
			if (triggered3)
			{
				break;
			}
			triggered3=true;			
			cutscenemode=true;
			ActivateCamera(toTrigger);
			sceneNumber=toTrigger;
			textStage=0;
			DisplayText();
			break;
		case 4:
			if (triggered4)
			{
				break;
			}
			triggered4=true;			
			cutscenemode=true;
			ActivateCamera(toTrigger);
			sceneNumber=toTrigger;
			textStage=0;
			DisplayText();
			break;
		case 5:
			if (triggered5)
			{
				break;
			}
			triggered5=true;			
			cutscenemode=true;
			ActivateCamera(toTrigger);
			sceneNumber=toTrigger;
			textStage=0;
			DisplayText();
			break;
		case 6:
			if (triggered6)
			{
				break;
			}
			triggered6=true;			
			cutscenemode=true;
			ActivateCamera(toTrigger);
			sceneNumber=toTrigger;
			textStage=0;
			DisplayText();
			break;
	}
	if (sceneNumber>0)
	{
		return;
	}
	
	if (Input.GetButton("Forward"))
	{
		transform.position += transform.forward * moveSpeed * Time.deltaTime;
	}
	if (Input.GetButton("Backward"))
	{
		transform.position += -transform.forward * moveSpeed * Time.deltaTime;
	}
	if (Input.GetButton("Left"))
	{
		transform.Rotate( 0.0, -turnSpeed*Time.deltaTime,0.0); 
		//transform.eulerAngles.y += -turnSpeed * Time.deltaTime;
	}
	if (Input.GetButton("Right"))
	{
		transform.Rotate( 0.0, turnSpeed*Time.deltaTime,0.0); 
	}
	if (Input.GetButtonDown("Jump"))
	{
		m_Grounded = Physics.Raycast (transform.position,
								  transform.up * -1,
                				  groundCastLength, 
                				  1 << LayerMask.NameToLayer ("Ground"));

		if (m_Grounded)
		{
			rigidbody.AddForce(transform.up * jumpForce);
		}
	}
	
}